# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: InstallWorkflows.py 615 2007-11-28 11:40:43Z frms $
#
from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import ExternalMethod

def installWorkflows(self, package, out):
    """Install the custom workflows for this product.
    """

    productname = 'Notifica'
    workflowTool = getToolByName(self, 'portal_workflow')

    ourProductWorkflow = ExternalMethod('temp',
                         'temp',
                         productname+'.'+'NotifNewsletter_Workflow',
                         'createNewsletter_Workflow')
    workflow = ourProductWorkflow(self, 'NotifNewsletter_Workflow')
    workflowTool._setObject('NotifNewsletter_Workflow', workflow)
    workflowTool.setChainForPortalTypes(['NotifNewsletter'], workflow.getId())

    subscriberWorkflow = ExternalMethod('temp',
                         'temp',
                         productname+'.'+'NotifNewsletter_Workflow',
                         'createSubscriber_Workflow')
    workflow = subscriberWorkflow(self, 'NotifSubscriber_Workflow')
    workflowTool._setObject('NotifSubscriber_Workflow', workflow)
    workflowTool.setChainForPortalTypes(['NotifSubscriber'], workflow.getId())

    return workflowTool
