# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: install_utils.py 615 2007-11-28 11:40:43Z frms $
#
from Products.CMFCore.utils import getToolByName
from Products.Notifica.config import *

def setMetaTypesNotToList(context, my_metatypes=None):
    """
    """
    if my_metatypes is None:
        my_metatypes = METATYPES_NOT_TO_LIST

    navtree_properties = getToolByName(context, "portal_properties").navtree_properties

    existing_metatypes = navtree_properties.getProperty("metaTypesNotToList")
    all_metatypes = list(existing_metatypes) + my_metatypes

    navtree_properties.manage_changeProperties(metaTypesNotToList = all_metatypes)

def installPortlet(self, outStream) :

    if hasattr(self, "right_slots") :
        if PORTLET in self.right_slots :
            outStream.write("%s portlet already installed, nothing to do.\n" % PROJECTNAME)
        else :
            right_slots_list = list(self.right_slots)
            self._delProperty('right_slots')
            right_slots_list.append(PORTLET)
            self._setProperty('right_slots', tuple(right_slots_list), 'lines')
            outStream.write("%s was installed on the right. To change this, edit the left and right_slots properties in the ZMI.\n" % PROJECTNAME)
    else :
        outStream.write("No attribute right_slots was found in context, nothing done. You have to add manually '%s' in the left and right_slots properties in the ZMI.\n" % PORTLET)

def installConfiglet(self, out) :
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in configlets:
            configTool.registerConfiglet(**conf)
            out.write('Added configlet %s\n' % conf['id'])

def installPortalFactory(self,out):
    factory = getToolByName(self, 'portal_factory', None)
    if factory is not None:
        types = factory.getFactoryTypes().keys()
        for metaType  in PROJECT_TYPES:
            if metaType not in types:
                types.append(metaType)
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
        out.write('Install types in portal_factory.' )

def uninstallPortalFactory(self, out):
    factory = getToolByName(self, 'portal_factory', None)
    if factory is not None:
        types = factory.getFactoryTypes().keys()
        for metaType in PROJECT_TYPES:
            if metaType in types:
                types.remove(metaType)
        factory.manage_setPortalFactoryTypes(listOfTypeIds = types)
        out.write('Removed content types from portal_factory.' )

def uninstallConfiglet(self, out) :
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in configlets:
            configTool.unregisterConfiglet(conf['id'])
            out.write('Removed configlet %s\n' % conf['id'])

def uninstallPortlet(self, outStream) :

    for attributeName in ["right_slots", "left_slots"] :
        try :
            attrib = getattr(self, attributeName)
            if PORTLET in attrib :
                slotsList = list(attrib)
                self._delProperty(attributeName)
                slotsList.remove(PORTLET)
                self._setProperty(attributeName, tuple(slotsList), 'lines')
                outStream.write("%s was removed from %s.\n" %(PROJECTNAME, attributeName))
            else :
                pass
#                 outStream.write("debug : portlet not found in %s.\n" % (attributeName))
        except AttributeError :
            outStream.write("Warning : No attribute %s was found in context.\n" % attributeName)
