# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: config.py 615 2007-11-28 11:40:43Z frms $
#
#
# Product configuration. This contents of this module will be imported into
# __init__.py and every content type module.
#
# If you wish to perform custom configuration, you may put a file AppConfig.py
# in your product's root directory. This will be included in this file if
# found.
#

from Products.CMFCore.permissions import setDefaultRoles
from Products.Archetypes import listTypes

DEFAULT_ALARM = 5

PROPERTIES = "notifica_properties"
SUBSCRIBERS_PATH = "subscribers_path"
NOTIFICA_PATH = "notifica_path"

PROJECTNAME = "Notifica"
PROJECT_TYPES =( "NotifSubscriber", "NotifNewsletter", "NotifTemplate")
# Check for Plone 2.1
try:
    from Products.CMFPlone.migrations import v2_1
except ImportError:
    HAS_PLONE21 = False
else:
    HAS_PLONE21 = True


product_globals=globals()

# Dependencies of Products to be installed by quick-installer
# override in custom configuration
DEPENDENCIES = []

# Dependend products - not quick-installed - used in testcase
# override in custom configuration
PRODUCT_DEPENDENCIES = []

# You can overwrite these two in an AppConfig.py:
# STYLESHEETS = [{'id': 'my_global_stylesheet.css'},
#                {'id': 'my_contenttype.css',
#                 'expression': 'python:object.getTypeInfo().getId() == "MyType"}]
# You can do the same with JAVASCRIPTS.
STYLESHEETS = []
JAVASCRIPTS = []

##code-section config-bottom #fill in your manual code here
STYLESHEETS = [{'id': 'notifica.css'},]
##/code-section config-bottom

# Portlet for subscribers
PORTLET = "here/portlet_notifica/macros/portlet"

# load custom configuration not managed by ArchGenXML
try:
    from Products.Notifica.AppConfig import *
except ImportError:
    pass
# Portlets of configuration
configlets = (
    {
        'id'         : 'notifica_config',
        'name'       : 'Notifica Configuration',
        'action'     : 'string:${portal_url}/notifica_config',
        'condition'  : '',
        'category'   : 'Products',    # section to which the configlet should be added:
                                      # (Plone,Products,Members)
        'visible'    : 1,
        'appId'      : PROJECTNAME,
        'permission' : 'ManagePortal',
        'imageUrl'   : 'notifica_config.gif',
    },
)
# End of config.py
