# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: NotifBase.py 615 2007-11-28 11:40:43Z frms $
# File: NotifBase.py


__author__  = 'Fco. Jose Mulero - GMV'
__docformat__ = 'plaintext'


from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATContentTypes.content.topic import ATTopic
from Products.CMFCore import permissions as CMFCorePermissions

from Products.Notifica.config import PROJECTNAME

from Products.ATContentTypes.content.base import updateActions


schema=Schema((
    #Overwritten to hide attribute from ATTopic
    BooleanField('acquireCriteria',
        default="False",
        widget=BooleanWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label="Inherit Criteria",
            label_msgid='notifica_label_inheritCriteria',
            description_msgid='notifica_help_inheritCriteria',
            i18n_domain='notifica',
        )
    ),

    #Overwritten to hide attribute from ATTopic
    BooleanField('limitNumber',
        widget=BooleanWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Limit number',
            label_msgid='notifica_label_limitNumber',
            description_msgid='notifica_help_limitNumber',
            i18n_domain='notifica',
        )
    ),

    #Overwritten to hide attribute from ATTopic
    BooleanField('itemCount',
        widget=BooleanWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Itemcount',
            label_msgid='notifica_label_itemCount',
            description_msgid='notifica_help_itemCount',
            i18n_domain='notifica',
        )
    ),

    #Overwritten to hide attribute from ATTopic
    BooleanField('customView',
        widget=BooleanWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Customview',
            label_msgid='Notifica_label_customView',
            description_msgid='Notifica_help_customView',
            i18n_domain='notifica',
        )
    ),

    #Overwritten to hide attribute from ATTopic
    BooleanField('customViewFields',
        widget=BooleanWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Customviewfields',
            label_msgid='Notifica_label_customViewFields',
            description_msgid='notifica_help_customViewFields',
            i18n_domain='notifica',
        )
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Base_schema = BaseSchema + getattr(ATTopic,'schema',Schema(())) + \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class NotifBase(ATTopic,BaseContent):
    """Responsibilities: Hide attributes from ATTopic"""
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATTopic,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),)

    archetype_name             = 'Base'
    meta_type                  = 'NotifBase'
    portal_type                = 'NotifBase'
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "Responsibilities: Hide attributes from ATTopic"
    typeDescMsgId              = 'description_edit_base'

    actions =  (


       {'action':      "string:${object_url}/subtopics",
        'category':    "object",
        'id':          'subtopics',
        'name':        'subtopics',
        'permissions': (CMFCorePermissions.ModifyPortalContent,),
        'condition'  : 'python:0'
       },


    )

    schema = Base_schema

    # Disallow ATTopic types
    allowed_content_types = []

    # Because AGX don't take notice of parent actions
    actions =  ATTopic.actions + actions

registerType(NotifBase,PROJECTNAME)
# end of class Base




