# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: NotifSubscriber.py 615 2007-11-28 11:40:43Z frms $
# File: NotifSubscriber.py

__author__  = 'Fco. Jose Mulero - GMV'
__docformat__ = 'plaintext'


from zope import interface
from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.CMFPlone.CatalogTool import registerIndexableAttribute
from Products.Notifica.interfaces.INotifSubscriber import INotifSubscriber
from Products.Notifica.config import PROJECTNAME
from Products.CMFCore import permissions as CMFCorePermissions

import re


from Products.Notifica.config import *
##code-section module-header #fill in your manual code here
##/code-section module-header

schema=Schema((
    StringField('title',
        widget=StringWidget(
            visible={'edit':'invisible', 'view':'invisible'},
            label='Title',
            label_msgid='Notifica_label_title',
            description_msgid='Notifica_help_title',
            i18n_domain='notifica',
        ),
        required=0
    ),

    StringField('email',
        widget=StringWidget(
            label='Email',
            label_msgid='Notifica_label_email',
            description_msgid='Notifica_help_email',
            i18n_domain='notifica',
        ),
        index="FieldIndex:schema",
        validators=('isEmail',),
        required=1
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Subscriber_schema = BaseSchema + schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class NotifSubscriber(BaseContent):
    """Subscriber of sindication service Notifica."""
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (INotifSubscriber,)



    # This name appears in the 'add' box
    archetype_name             = 'Subscriber'

    meta_type                  = 'NotifSubscriber'
    portal_type                = 'NotifSubscriber'
    content_icon               = 'user.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    suppl_views                = ()
    typeDescription            = 'Subscriber of sindication service Notifica.'
    typeDescMsgId              = 'description_edit_subscriber'

    actions =  (


       {'action':      "string:${object_url}/base_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (CMFCorePermissions.ManagePortal,),
        'condition'  : 'python:1'
       },

    )

    _at_rename_after_creation  = True

    schema = Subscriber_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header
    #Methods
    #manually created methods

    security.declarePublic('setEmail')
    def setEmail(self, value):
        """
        """
        self.email = value
        self.title = value

        # reindex to set title for catalog
        self.reindexObject()

    security.declarePublic('Title')
    def Title(self):
        """Overwritten accessor for Title
        """
        return self.getEmail()

registerType(NotifSubscriber,PROJECTNAME)
# end of class NotifSubscriber

##code-section module-footer #fill in your manual code here
##/code-section module-footer



