# -*- coding: utf-8 -*-
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: NotifTemplate.py 615 2007-11-28 11:40:43Z frms $
#
__author__  = 'Fco. Jose Mulero - GMV'
__docformat__ = 'plaintext'


from zope import interface
from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.Notifica.interfaces.INotifTemplate import INotifTemplate
from Products.CMFCore import permissions as CMFCorePermissions

from Products.Notifica.config import *
##code-section module-header #fill in your manual code here
from Products.TemplateFields import ZPTField
import re
##/code-section module-header

schema=Schema((
    ZPTField('body',
       widget = TextAreaWidget(
            rows = 25,
            label_msgid="notifica_template_label_body",
            description_msgid="notifica_template_help_body",
            description="Content of the template.",
            i18n_domain="notifica",
            label='Body',
        ),
        validators=( 'zptvalidator',)
    ),

    TextField('description',
        widget=TextAreaWidget(
            label_msgid="label_description",
            description_msgid="help_description",
            description="Enter a value for description.",
            i18n_domain="plone",
            label='Description',
        ),
        accessor="Description"
    ),

),
)


##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

Template_schema = BaseSchema+ \
    schema

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class NotifTemplate(BaseContent):
    """Template"""
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),) + (INotifTemplate,)


    # This name appears in the 'add' box
    archetype_name             = 'Template'

    meta_type                  = 'NotifTemplate'
    portal_type                = 'NotifTemplate'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'Template.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "Template"
    typeDescMsgId              = 'description_edit_template'

    _at_rename_after_creation  = True

    schema = Template_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods
    #methods from Interface IENLTTemplate

    security.declareProtected(CMFCorePermissions.View, 'getSourceCode')
    def getSourceCode(self):
        """Return body as string

        """
        html =  self.getField("body").getRaw(self)
        return html



    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'setNewsletter')
    def setNewsletter(self,newsletter):
        """Sets the newsletter which should be used by the template
        """
        self.newsletter = newsletter



    security.declareProtected(CMFCorePermissions.View,'getObjects')
    def getObjects(self):
        """Returns the objects dependend on actual passed newsletter.
           For convenient use in the ZPT of the NotifTemplate
        """
        try:
            if self.newsletter is not None:
                return self.newsletter.queryCatalog(batch=True)
        except:
            pass

    #manually created methods

    security.declareProtected(CMFCorePermissions.View,'getNewsletter')
    def getNewsletter(self):
        """Returns the newsletter which should be used by the template in body
        """
        return self.newsletter

    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'initializeArchetype')
    def initializeArchetype(self, **kwargs):
        """overwritten hook
        """
        BaseContent.initializeArchetype(self, **kwargs)
        self.setBody(DEFAULT_TEMPLATE)



registerType(NotifTemplate,PROJECTNAME)
# end of class NotifTemplate

##code-section module-footer #fill in your manual code here
##/code-section module-footer



