
# Script for sending newsletter using Notifica
#
# Notifica
# Copyright (C) 2007 GMV SGI Team <http://www.gmv-sgi.es>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 2 of the GNU General Public
# License as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# $Id: sendNewsletterTask.py 615 2007-11-28 11:40:43Z frms $
#

# Import a standard function, and get the HTML request and response objects.
from Products.PythonScripts.standard import html_quote
from Products.CMFCore.utils import getToolByName

request = container.REQUEST
RESPONSE =  request.RESPONSE

# Return a string identifying this script.
print "This is the", script.meta_type, '"%s"' % script.getId(),
if script.title:
    print "(%s)" % html_quote(script.title)

#Get the portal catalog to search all Notifica objects
portal_catalog = getToolByName(context, 'portal_catalog')
query = {}
query["portal_type"] = "Notifica"

notificas = portal_catalog.searchResults(**query)

error_msg = ''
if len(notificas)==0:
   msg = "Notifica: There are not Notifica objects"
   print msg

#Send Newsletters
for notifica in notificas:
   notif = notifica.getObject()
   if(notif.getAutomaticSend()):
       try:
          notifica.getObject().sendNewsletter()
       except:
          error_msg = "Notifica: Sending newsletter error"
          print error_msg

#If no errors print an OK message
if error_msg =='':
   msg = "Notifica: Sending Newsletter OK"
   print msg

portal_catalog.refreshCatalog()

return printed